<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

ob_start();  //Ausgabe-Pufferung starten

$ko_path = "../";
$ko_menu_akt = "groups";

include($ko_path . "inc/ko.inc");
include("inc/groups.inc");

if(!ko_module_installed("groups")) {
	header("Location: ".$BASE_URL."index.php");  //Absolute URL
}

ob_end_flush();  //Puffer flushen

$error = $info = 0;

//Get access rights
ko_get_access('groups');

//kOOL Table Array
ko_include_kota(array('ko_groups'));


//Alle Gruppen einlesen
ko_get_groups($all_groups);


//*** Plugins einlesen:
$hooks = hook_include_main("groups");
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);


//***Action auslesen:
if($_POST["action"]) $do_action = $_POST["action"];
else if($_GET["action"]) $do_action = $_GET["action"];
else $do_action = "";

switch($do_action) {

	/**
	  * Anzeige
		*/
	case "list_groups":
		if(isset($_GET["gid"])) {
			if($_GET["gid"] == "NULL") $_SESSION["show_gid"] = "NULL";
			else $_SESSION["show_gid"] = format_userinput($_GET["gid"], "uint");
		} else {
			if(!isset($_SESSION["show_gid"]) || ko_get_userpref($_SESSION["ses_userid"], "groups_show_top") == 1) $_SESSION["show_gid"] = "NULL";
		}

		$id = $_SESSION["show_gid"];
		if( ($id == 'NULL' && $access['groups']['MAX'] > 0) || ($id != '' && ($access['groups']['ALL'] > 0 || $access['groups'][$id] > 0))) {
			$_SESSION["show"] = "list_groups";
			$_SESSION["show_start"] = 1;
			$_SESSION["show_back"] = $_SESSION["show"];
		}
	break;

	case "list_roles":
		if($access['groups']['MAX'] < 1) continue;
		$_SESSION["show"] = "list_roles";
		$_SESSION["show_back"] = $_SESSION["show"];
	break;

	case "list_datafields":
		if($access['groups']['MAX'] < 3) continue;
		$_SESSION["show"] = "list_datafields";
		$_SESSION["show_back"] = $_SESSION["show"];
	break;

	case "groups_settings":
		$_SESSION["show"] = "groups_settings";
	break;

	case "exportxls":
		if($access['groups']['MAX'] < 1) continue;

		//Gruppen
		ko_get_grouproles($roles);
		$groups = ko_groups_get_recursive(ko_get_groups_zwhere(), TRUE);
		$rowcounter = 0;

		//Find deepest level for intending
		$deepest_level = 0;
		foreach($groups as $gid => $grp) {
			if($access['groups']['ALL'] < 1 && $access['groups'][$grp['id']] < 1) {
				unset($groups[$gid]);
				continue;
			}
			//Kein Kreis-Vererbungen erlauben
			$mother_line = ko_groups_get_motherline($grp["id"], $all_groups);
			$groups[$gid]['_motherline'] = $mother_line;
			$deepest_level = max($deepest_level, sizeof($mother_line));
		}

		//Add header row
		$headerrow = array(getLL('kota_ko_groups_name'));
		for($i=0; $i<$deepest_level; $i++) {
			$headerrow[] = "";
		}
		$headerrow[] = getLL('kota_ko_groups_description');
		$headerrow[] = getLL('kota_ko_groups_start');
		$headerrow[] = getLL('kota_ko_groups_stop');
		$headerrow[] = getLL('kota_ko_groups_roles');

		//Prepare output, every group on a row
		foreach($groups as $grp) {
			//Display hierarchy
			for($i=0; $i<sizeof($grp['_motherline']); $i++) $data[$rowcounter][] = "";
			//Name and total members
			$num = db_get_count("ko_leute", "id", "AND `deleted` = '0' AND `hidden` = '0' AND `groups` REGEXP 'g".$grp["id"]."'");
			$data[$rowcounter][] = $grp["name"]." ($num)";

			//Add empty rows according to the depth of this group's level
			for($i=0; $i<($deepest_level-sizeof($grp['_motherline'])); $i++) {
				$data[$rowcounter][] = "";
			}

			$data[$rowcounter][] = $grp["description"] ? $grp["description"] : "-";

			if($grp["type"]) {  //Dummy group
				//Stop here
			}
			//not a dummy group
			else {
				$data[$rowcounter][] = $grp["start"] != "0000-00-00" ? strftime($DATETIME["dmY"], strtotime($grp["start"])) : "-";
				$data[$rowcounter][] = $grp["stop"] != "0000-00-00" ? strftime($DATETIME["dmY"], strtotime($grp["stop"])) : "-";
				//Roles
				foreach(explode(",", $grp["roles"]) as $rid) {
					if(!$rid) continue;
					$num = db_get_count("ko_leute", "id", "AND `deleted` = '0' AND `hidden` = '0' AND `groups` REGEXP 'g".$grp["id"].":r".$rid."'");
					$data[$rowcounter][] = $num."x".$roles[$rid]["name"];
				}
			}
			$rowcounter++;
		}

		$filename = getLL("groups_filename_all").strftime("%d%m%Y_%H%M%S", time()).".xls";
		$title = getLL("groups_exportxls_title");
		ko_export_to_excel($headerrow, $data, ($ko_path."download/excel/".$filename), $title);
		$onload_code = "popup('".$ko_path."download.php?action=file&amp;file=download/excel/$filename', 400, 300);";
	break;



	/**
	  * Neu
		*/
	case "new_group":
		if($access['groups']['MAX'] < 3) continue;
		$_SESSION["show"] = "new_group";
		$onload_code = "form_set_first_input();".$onload_code;
	break;


	case "submit_new_group":
		if($access['groups']['MAX'] < 3) continue;

		$data = array();
		$data["name"]            = format_userinput($_POST["txt_name"], "js");
		$data["description"]     = format_userinput($_POST["txt_description"], "text");
		$data["start"]           = sql_datum(format_userinput($_POST["txt_datum"], "date"));
		$data["stop"]            = sql_datum(format_userinput($_POST["txt_datum2"], "date"));
		$data["pid"]             = format_userinput($_POST["sel_parentgroup"], "uint");
		$data["pid"]             = $data["pid"] ? $data["pid"] : "NULL";
		$data["roles"]           = format_userinput($_POST["sel_roles"], "intlist");
		$data["rights_view"]     = format_userinput($_POST["sel_rights_view"], "intlist");
		$data["rights_new"]      = format_userinput($_POST["sel_rights_new"], "intlist");
		$data["rights_edit"]     = format_userinput($_POST["sel_rights_edit"], "intlist");
		$data["crdate"]          = strftime("%Y-%m-%d %H:%M:%S", time());
		$data["type"]            = format_userinput($_POST["chk_type"], "uint");
		$data["datafields"]      = format_userinput($_POST["sel_datafields"], "intlist");
		$data["ezmlm_list"]      = format_userinput($_POST["txt_ezmlm_list"], "email");
		$data["ezmlm_moderator"] = format_userinput($_POST["txt_ezmlm_moderator"], "email");

		//In DB Speichern
		$new_id = db_insert_data("ko_groups", $data);
		ko_get_groups($all_groups);
		//Loggen
		ko_log_diff("new_group", $data);
		//update datafields for all kids-groups
		//if($data["datafields"]) ko_update_groups_datafields($new_id, $data["datafields"]);

		$_SESSION["show"] = "list_groups";
		$info = 3;
	break;


	case "new_role":
		if($access['groups']['MAX'] < 3) continue;

		$_SESSION["show"] = "new_role";
		$onload_code = "form_set_first_input();".$onload_code;
	break;

	case "submit_new_role":
		if($access['groups']['MAX'] < 3) continue;

		$data["name"] = format_userinput($_POST["txt_name"], "js");

		db_insert_data("ko_grouproles", $data);
		ko_log_diff("new_grouprole", $data);
		ko_update_grouprole_filter();
		$_SESSION["show"] = "list_roles";
		$info = 4;
	break;




	/**
	  * Bearbeiten
		*/
	case "edit_group":
		$edit_id = format_userinput($_POST["id"], "uint");
		if($access['groups']['ALL'] > 2 || $access['groups'][$edit_id] > 2) {
			$_SESSION["show"] = "edit_group";
			$onload_code = "form_set_first_input();".$onload_code;
		}
	break;


	case "submit_edit_group":
		$id = format_userinput($_POST["id"], "uint");
		if($access['groups']['ALL'] < 3 && $access['groups'][$id] < 3) continue;

		$old_group = $all_groups[$id];

		$data = array();
		$data["name"]            = format_userinput($_POST["txt_name"], "js");
		$data["description"]     = format_userinput($_POST["txt_description"], "text");
		$data["start"]           = sql_datum(format_userinput($_POST["txt_datum"], "date"));
		$data["stop"]            = sql_datum(format_userinput($_POST["txt_datum2"], "date"));
		$data["pid"]             = format_userinput($_POST["sel_parentgroup"], "uint");
		$data["pid"]             = $data["pid"] ? $data["pid"] : "NULL";
		$data["roles"]           = format_userinput($_POST["sel_roles"], "intlist");
		$data["type"]            = format_userinput($_POST["chk_type"], "uint");
		$data["datafields"]      = format_userinput($_POST["sel_datafields"], "intlist");
		$data["ezmlm_list"]      = format_userinput($_POST["txt_ezmlm_list"], "email");
		$data["ezmlm_moderator"] = format_userinput($_POST["txt_ezmlm_moderator"], "email");

		//Rechte
    if(isset($_POST["sel_rights_view"])) {  //Only handle rights, if set in form
      $data["rights_view"] = format_userinput($_POST["sel_rights_view"], "intlist");
      $data["rights_new"]  = format_userinput($_POST["sel_rights_new"], "intlist");
      $data["rights_edit"] = format_userinput($_POST["sel_rights_edit"], "intlist");
      //Rechte aufrumen
      $rv = explode(",", $data["rights_view"]);
      $rn = explode(",", $data["rights_new"]);
      $re = explode(",", $data["rights_edit"]);
      foreach($rv as $i => $v) if(in_array($v, $rn) || in_array($v, $re)) unset($rv[$i]);
      foreach($rn as $i => $v) if(in_array($v, $re)) unset($rn[$i]);
      $data["rights_view"] = implode(",", $rv);
      $data["rights_new"] = implode(",", $rn);
    }
	
		//In DB speichern
		db_update_data("ko_groups", "WHERE `id` = '$id'", $data);
		ko_get_groups($all_groups);
		//Loggen
		ko_log_diff("edit_group", $data, $old_group);
		//Eingetragene Gruppen/Rollen in Personendaten aktualisieren
		ko_update_groups_and_roles();
		//Berechtigungen so anpassen, dass die ganze Mutterlinie minimum 1-Rechte hat (damit diese Gruppe berhaupt anzeigen darf)
		ko_update_groups_rights($id);
		//Delete entries of datafields not used anymore
		$new_df = explode(",", $data["datafields"]);
		foreach(explode(",", $old_group["datafields"]) as $df) {
			if(in_array($df, $new_df)) continue;
			else db_delete_data("ko_groups_datafields_data", "WHERE `group_id` = '$id' AND `datafield_id` = '$df'");
		}
		//Initial export to ezmlm if given
		if($_POST["chk_ezmlm_export"]) ko_export_group_to_ezmlm($id);

		$_SESSION["show"] = "list_groups";
		$info = 2;
	break;


	case "edit_role":
		$edit_id = format_userinput($_POST["id"], "uint");
		if($access['groups']['MAX'] < 3) continue;

		//Prfen, ob alle Gruppen, in denen diese Rolle verwendet wird, bearbeitbar sind
		$groups = db_select_data("ko_groups", "WHERE `roles` LIKE '$edit_id'");
		$do_edit = TRUE;
		foreach($groups as $group) {
			if($access['groups']['ALL'] < 3 && $access['groups'][$group['id']] < 3) $do_edit = FALSE;
		}
		if($do_edit) {
			$_SESSION["show"] = "edit_role";
			$onload_code = "form_set_first_input();".$onload_code;
		}
	break;


	case "submit_edit_role":
		$id = format_userinput($_POST["id"], "uint");
		if($access['groups']['MAX'] < 3) continue;

		//Prfen, ob alle Gruppen, in denen diese Rolle verwendet wird, bearbeitbar sind
		$groups = db_select_data("ko_groups", "WHERE `roles` LIKE '$id'");
		if(sizeof($groups) == 0) {  //Noch nirgends verwendet
			$do_edit = ($access['groups']['ALL'] > 2);
		} else {
			$do_edit = TRUE;
			foreach($groups as $group) {
				if($access['groups']['ALL'] < 3 && $access['groups'][$group['id']] < 3) $do_edit = FALSE;
			}
		}

		if($do_edit) {
			ko_get_grouproles($old_role, "AND `id` = '$id'");

			$data["name"] = format_userinput($_POST["txt_name"], "js");
			
			db_update_data("ko_grouproles", "WHERE `id` = '$id'", $data);
			ko_log_diff("edit_group", $data, $old_role[$id]);
			ko_update_grouprole_filter();
			$_SESSION["show"] = "list_roles";
			$info = 2;
		}
	break;



	case "edit_datafield":
		$edit_id = format_userinput($_POST["id"], "uint");
		if($access['groups']['MAX'] < 3) continue;

		$_SESSION["show"] = "edit_datafield";
		$onload_code = "form_set_first_input();".$onload_code;
	break;


	case "submit_edit_datafield":
		$id = format_userinput($_POST["id"], "uint");
		if($access['groups']['MAX'] < 3) continue;

		$data["description"] = format_userinput($_POST["txt_description"], "js");
		$data["type"] = format_userinput($_POST["sel_type"], "alpha");
		if( $_POST["txt_options"] && in_array($data["type"], array("select", "multiselect")) ) {
			$opt = explode("\n", $_POST["txt_options"]);
			$opts = NULL;
			foreach($opt as $o) {
				$opts[] = format_userinput($o, "js");
			}
			$data["options"] = serialize($opts);
		} else {
			$data["options"] = "";
		}
		$data["reusable"] = format_userinput($_POST["chk_reusable"], "uint");
		
		if(in_array($data["type"], array("text", "textarea", "checkbox", "select", "multiselect"))) {
			$old = db_select_data("ko_groups_datafields", "WHERE `id` = '$id'");
			db_update_data("ko_groups_datafields", "WHERE `id` = '$id'", $data);
			ko_log_diff("edit_datafield", $data, $old);
			$info = 2;
		}
		$_SESSION["show"] = "list_datafields";
	break;





	/**
	  * Lschen
		*/
	case "delete_group":
		$del_id = format_userinput($_POST["id"], "uint");
		if(($access['groups']['ALL'] > 2 || $access['groups'][$del_id] > 2) && db_get_count('ko_groups', 'id', "AND `pid` = '$del_id'") == 0 ) {
			//Gruppe lschen
			db_delete_data("ko_groups", "WHERE `id` = '$del_id'");
			//Gruppen-Datenfelder-Daten lschen
			db_delete_data("ko_groups_datafields_data", "WHERE `group_id` = '$del_id'");
			//Alle Parent-Eintrage von Subgruppen lschen
			db_update_data("ko_groups", "WHERE `pid` = '$del_id'", array("pid" => "NULL"));
			ko_get_groups($all_groups);
			//Loggen
			ko_log_diff("del_group", $all_groups[$del_id]);
			//Gespeicherte Gruppenzuteilungen der Leute aktualisieren
			ko_update_groups_and_roles();

			$info = 1;
		}
	break;


	//Sicherheits-Abfrage!
	case "delete_role":
		$del_id = format_userinput($_POST["id"], "uint");
		if($access['groups']['MAX'] > 2) {
			$_SESSION["show"] = "delete_role";
		}
	break;


	//Wirklich lschen
	case "do_delete_role":
		$del_id = format_userinput($_POST["id"], "uint");
		if($access['groups']['MAX'] > 2) {
			ko_get_grouproles($old_role, "AND `id` = '$del_id'");
			//Rolle lschen
			db_delete_data("ko_grouproles", "WHERE `id` = '$del_id'");
			//Rollen in alle Gruppen lschen, in denen sie vorkommt
			$gruppen = db_select_data("ko_groups", "WHERE `roles` REGEXP '$del_id'");
			foreach($gruppen as $gruppe) {
				$roles = explode(",", $gruppe["roles"]);
				foreach($roles as $r_i => $role) if($role == $del_id) unset($roles[$r_i]);
				db_update_data("ko_groups", "WHERE `id` = '".$gruppe["id"]."'", array("roles" => implode(",", $roles)));
			}
			//Gespeicherte Gruppenzuteilungen der Leute aktualisieren
			ko_update_groups_and_roles();
			//Loggen
			ko_log_diff("del_grouprole", $old_role[$del_id]);
			ko_update_grouprole_filter();

			$info = 1;
		}
		$_SESSION["show"] = "list_roles";
	break;



	case "delete_datafield":
		$del_id = format_userinput($_POST["id"], "uint");
		if($access['groups']['MAX'] < 3) continue;

		//Prfen, ob Datenfeld noch irgendwo verwendet wird, dann kann man es nicht lschen
		$num = db_get_count("ko_groups", "id", "AND `datafields` REGEXP '$del_id'");
		if($num == 0) {
			$old = db_select_data("ko_groups_datafields", "WHERE `id` = '$del_id'");
			db_delete_data("ko_groups_datafields", "WHERE `id` = '$del_id'");
			ko_log("del_datafield", $old["description"]." (".$old["type"].")");
		}
	break;





	/**
	  * Berechtigungen
		*/
	case "propagate_rights":
		if($access['groups']['MAX'] < 3) $error = 1;
		if(sizeof($_POST["chk"]) == 0) {
			$error = 2;
		}
		if($error) continue;
	
		//Gewhlte Gruppen auslesen
		$group_ids = array();
		foreach($_POST["chk"] as $c_i => $c) {
			if($c) $group_ids[] = $c_i;
		}

		//Durch alle Gruppen und deren Kinder durchgehen
		foreach($group_ids as $id) {
			$children = array();
			$group = $all_groups[$id];
			//New access rights from the mothergroup
			$new = array('rights_view' => $group['rights_view'],
									 'rights_new'  => $group['rights_new'],
									 'rights_edit' => $group['rights_edit']);
			rec_groups($group, $children);
			foreach($children as $child) {
				db_update_data('ko_groups', "WHERE `id` = '".$child['id']."'", $new);
			}
		}//foreach(group_ids as id)
		
		$info = 5;
	break;


	case "list_rights":
		if($access['groups']['MAX'] < 3) continue;
		$_SESSION["show_start"] = 1;
		$_SESSION["show"] = "list_rights";
		$_SESSION["show_back"] = $_SESSION["show"];
	break;


	case "edit_login_rights":
		$edit_id = format_userinput($_POST["id"], "uint");
		if(!$edit_id) continue;
		$_SESSION["show"] = "edit_login_rights";
	break;


	case "submit_edit_login_rights":
		if($access['groups']['ALL'] < 3) continue;
		$login_id = format_userinput($_POST["id"], "uint");
		if(!$login_id || ($login_id == ko_get_root_id() && $_SESSION["ses_userid"] != ko_get_root_id()) ) continue;

		//Loop ber die drei Rechte-Stufen
		$mode = array("", "view", "new", "edit");
		for($i=3; $i>0; $i--) {
			if(isset($_POST["sel_rights_".$mode[$i]])) {
				//Nur nderungen bearbeiten
				$old = explode(",", format_userinput($_POST["old_sel_rights_".$mode[$i]], "intlist", FALSE, 0, array(), ":"));
				$new = explode(",", format_userinput($_POST["sel_rights_".$mode[$i]], "intlist", FALSE, 0, array(), ":"));
				$deleted = array_diff($old, $new);
				$added = array_diff($new, $old);
			
				//Login aus gelschten Gruppen entfernen
				foreach($deleted as $id) {
					$id = substr($id, -6);  //Nur letzte ID verwenden, davor steht die Motherline
					//bisherige Rechte auslesen
					$group = db_select_data("ko_groups", "WHERE `id` = '$id'", "id,rights_".$mode[$i]);
					$rights_array = explode(",", $group[$id]["rights_".$mode[$i]]);
					//Zu lschendes Login finden und entfernen
					foreach($rights_array as $index => $right) if($right == $login_id) unset($rights_array[$index]);
					foreach($rights_array as $a => $b) if(!$b) unset($rights_array[$a]);  //Leere Eintrge lschen
					//Neuer Eintrag in Gruppe speichern
					db_update_data("ko_groups", "WHERE `id` = '$id'", array("rights_".$mode[$i] => implode(",", $rights_array)));
					$all_groups[$id]['rights_'.$mode[$i]] = implode(',', $rights_array);
					//Beim Lschen von View-Rechten knnte die Verbindung zu tieferliegenden Gruppen gelscht werden, deshalb korrigieren
				}

				//Login in neu hinzugefgten Gruppen hinzufgen
				foreach($added as $id) {
					$id = substr($id, -6);  //Nur letzte ID verwenden, davor steht die Motherline
					//Bestehende Rechte auslesen
					$group = db_select_data("ko_groups", "WHERE `id` = '$id'", "id,rights_".$mode[$i]);
					$rights_array = explode(",", $group[$id]["rights_".$mode[$i]]);
					//berprfen, ob Login schon vorhanden ist (sollte nicht)
					$add = TRUE;
					foreach($rights_array as $right) if($right == $login_id) $add = FALSE;
					if($add) $rights_array[] = $login_id;
					foreach($rights_array as $a => $b) if(!$b) unset($rights_array[$a]);  //Leere Eintrge lschen
					//Neue Liste der Logins in Gruppe speichern
					db_update_data("ko_groups", "WHERE `id` = '$id'", array("rights_".$mode[$i] => implode(",", $rights_array)));
					$all_groups[$id]['rights_'.$mode[$i]] = implode(',', $rights_array);
					//sicherstellen, dass View-Rechte fr alle oberhalb liegenden Gruppe vorhanden ist
				}
			}//if(isset(_POST[sel_rights_*]))
		}//for(i=1..3)

		//Update rights, so level 1 acces is granted to all parents of all selected groups
		$groups = db_select_data('ko_groups', "WHERE `rights_view` REGEXP '(^|,)$login_id(,|$)' OR `rights_new` REGEXP '(^|,)$login_id(,|$)' OR `rights_edit` REGEXP '(^|,)$login_id(,|$)'", '*');
		foreach($groups as $g) {
			ko_update_groups_rights($g['id']);
		}

		$_SESSION["show"] = 'list_rights';
	break;



	case "submit_groups_settings":
		$value = isset($_POST["chk_groups_show_top"]) ? 1 : 0;
		ko_save_userpref($_SESSION["ses_userid"], "groups_show_top", $value);

		$_SESSION["show"] = $_SESSION["show_back"] ? $_SESSION["show_back"] : "groups_settings";
	break;




	case "multiedit":
		if($_SESSION["show"] == "list_groups") {
			if($access['groups']['MAX'] < 3) continue;

			//Zu bearbeitende Spalten
			$columns = explode(",", format_userinput($_POST["id"], "alphanumlist"));
			foreach($columns as $column) {
				$do_columns[] = $column;
			}
			if(sizeof($do_columns) < 1) $error = 8;

			//Zu bearbeitende Eintrge
			$do_ids = array();
			foreach($_POST["chk"] as $c_i => $c) {
				if($c) {
					if(FALSE === ($edit_id = format_userinput($c_i, "uint", TRUE))) {
						trigger_error("Not allowed multiedit_id: ".$c_i, E_USER_ERROR);
					}
					if($access['groups']['ALL'] > 2 || $access['groups'][$edit_id] > 2) $do_ids[] = $edit_id;
				}
			}
			if(sizeof($do_ids) < 1) $error = 2;

			//Daten fr Formular-Aufruf vorbereiten
			if(!$error) {
				$order = "ORDER BY ".$_SESSION["sort_groups"]." ".$_SESSION["sort_groups_order"];
				$_SESSION["show_back"] = $_SESSION["show"];
				$_SESSION["show"] = "multiedit";
			}


		/* Rollen */
		} else if($_SESSION["show"] == "list_roles") {
		}

		$onload_code = "form_set_first_input();".$onload_code;
	break;



	case "submit_multiedit":
		if($_SESSION["show"] == "multiedit") {
			if($access['groups']['MAX'] < 3) continue;
			kota_submit_multiedit($error, 3);
		} else if($_SESSION["show"] == "multiedit_roles") {
			if($access['groups']['MAX'] < 3) continue;
			kota_submit_multiedit($error, 3);
		}

		if(!$error) $info = 6;
		$_SESSION["show"] = $_SESSION["show_back"] ? $_SESSION["show_back"] : "list_groups";
	break;






	//Submenus
  case "move_sm_left":
  case "move_sm_right":
    ko_submenu_actions("groups", $do_action);
  break;


	//Default:
  default:
	if(!hook_action_handler($do_action))
    include($ko_path."inc/abuse.inc");
  break;


}//switch(do_action)

//HOOK: Plugins erlauben, die bestehenden Actions zu erweitern
hook_action_handler_add($do_action);


//Reread access rights if necessary
if(in_array($do_action, array('submit_new_group', 'submit_edit_group', 'delete_group', 'submit_edit_login_rights', 'propagate_rights'))) {
	ko_get_access('groups', '', TRUE);
	ko_get_groups($all_groups);
}


//***Defaults einlesen
if(!$_SESSION["sort_groups"]) $_SESSION["sort_groups"] = "name";
if(!$_SESSION["sort_groups_order"]) $_SESSION["sort_groups_order"] = "ASC";
if(!$_SESSION["show_start"]) $_SESSION["show_start"] = 1;
$_SESSION["show_limit"] = ko_get_userpref($_SESSION["ses_userid"], "show_limit_groups");
if(!$_SESSION["show_limit"]) $_SESSION["show_limit"] = ko_get_setting("show_limit_groups");

//Smarty-Templates-Engine laden
require("$ko_path/inc/smarty.inc");

//Include submenus
ko_set_submenues();

//HOOK: Submenus einlesen
$hooks = hook_include_sm();
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);

?>

<!DOCTYPE html 
  PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php print $_SESSION["lang"]; ?>" lang="<?php print $_SESSION["lang"]; ?>">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<title><?php print "$HTML_TITLE: ".getLL("module_".$ko_menu_akt); ?></title>
<link rel="stylesheet" type="text/css" href="<?php print $ko_path; ?>kOOL.css" />
<!--[if lte IE 6]>
<link rel="stylesheet" type="text/css" href="<?php print $ko_path; ?>ie6.css" />
<![endif]-->
<!--[if IE 7]>
<link rel="stylesheet" type="text/css" href="<?php print $ko_path; ?>ie7.css" />
<![endif]-->
<link rel="stylesheet" type="text/css" href="<?php print $ko_path; ?>ko.css" />
<?php
print '<script type=\'text/javascript\' src=\''.$ko_path.'inc/kOOL.js\'></script>';
include($ko_path.'inc/js-sessiontimeout.inc');
include("inc/js-groups.inc");
$js_calendar->load_files();

//Bei der Bearbeitung von Login-Rechten Ajax einbinden und alles fr die drei selectmenus
if($_SESSION["show"] == "edit_login_rights") {
	print '<script type=\'text/javascript\' src=\''.$ko_path.'inc/selectmenu.js\'></script>';
	//dont show dummy-groups (Platzhalter), because then a user might think, the rights will be propagated downwards to all children (which they dont)
	$show_all_types = FALSE;
	//View
	$list_id = 1;
	include($ko_path."leute/inc/js-groupmenu.inc");
	$loadcode = "initList($list_id, document.formular.sel_ds1_sel_rights_view);";
	//New
	$list_id = 2;
	include($ko_path."leute/inc/js-groupmenu.inc");
	$loadcode .= "initList($list_id, document.formular.sel_ds1_sel_rights_new);";
	//Edit
	$list_id = 3;
	include($ko_path."leute/inc/js-groupmenu.inc");
	$loadcode .= "initList($list_id, document.formular.sel_ds1_sel_rights_edit);";
	$onload_code = $loadcode.$onload_code;
}
?>
</head>

<body onload="session_time_init();<?php print $onload_code; ?>" oncontextmenu="return false;">

<?php
/*
 * Gibt bei erfolgreichem Login das Men aus, sonst einfach die Loginfelder
 */
include($ko_path . "menu.php");
?>


<form action="index.php" method="post" name="formular">  <!-- Hauptformular -->
<input type="hidden" name="action" id="action" value="" />
<input type="hidden" name="id" id="id" value="" />

<table width="100%">
<tr> 

<!-- Submenu -->
<td class="main_left" name="main_left" id="main_left">
<?php
print ko_get_submenu_code("groups", "left");
?>
&nbsp;
</td>


<!-- Hauptbereich -->
<td class="main" name="main_content" id="main_content">
<?php
if($info) {
	$info_txt = getLL("info_groups_".$info);
	print '<div class="infotxt">'.$info_txt.'</div><br />';
}

if($error) {
	$error_txt = getLL("error_groups_".$error);
	ko_error_log(getLL("module_groups"), $error, $error_txt, $do_action);
	print '<div class="errortxt">'.$error_txt.'</div><br />';
}

hook_show_case_pre($_SESSION["show"]);

switch($_SESSION["show"]) {

	case "list_groups":
		ko_groups_list();
	break;

	case "new_group":
		ko_groups_formular_group("neu");
	break;

	case "edit_group":
		ko_groups_formular_group("edit", $edit_id);
	break;

	case "list_roles":
		ko_groups_list_roles();
	break;

	case "new_role":
		ko_groups_formular_role("neu");
	break;

	case "edit_role":
		ko_groups_formular_role("edit", $edit_id);
	break;

	case "delete_role":
		ko_delete_role($del_id);
	break;

	case "list_datafields":
		ko_groups_list_datafields();
	break;

	case "edit_datafield":
		ko_groups_formular_datafield("edit", $edit_id);
	break;

	case "multiedit":
		ko_multiedit_formular("ko_groups", $do_columns, $do_ids, $order, array("cancel" => "list_groups"));
	break;

	case "list_rights":
		ko_groups_list_rights();
	break;

	case "edit_login_rights":
		ko_groups_rights_formular($edit_id);
	break;

	case "groups_settings":
		ko_groups_settings();
	break;


	default:
		//HOOK: Plugins erlauben, neue Show-Cases zu definieren
    hook_show_case($_SESSION["show"]);
  break;
}//switch(show)

//HOOK: Plugins erlauben, die bestehenden Show-Cases zu erweitern
hook_show_case_add($_SESSION["show"]);

?>
&nbsp;
</td>

<td class="main_right" name="main_right" id="main_right">

<?php
print ko_get_submenu_code("groups", "right");
?>
&nbsp;
</td>
</tr>

<?php include($ko_path . "footer.php"); ?>

</table>
</form> <!-- //Hauptformular -->

</body>
</html>
